package balance
{
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	public class calcDisplay extends Sprite
	{
		[Embed(source = "../../lib/display.png")]
		private var displayImage:Class;
		
		public var Label:TextField;	
		public var maxCharacters:int;
		
		public function calcDisplay(maxChars:int):void
		{
			var img:Bitmap = new displayImage();
			addChild(img);
			img.scaleX = 0.79;
			
			Label = new TextField();
			Label.type = TextFieldType.DYNAMIC;
			Label.selectable = false;
			Label.text  = "";
			Label.width = 100;
			Label.x = 4;
			Label.y = 4;
			addChild(Label);			
			
			buttonMode = false;
			tabEnabled = false;
			maxCharacters = maxChars;
		}
		
		public function refresh(str:String):void
		{
			if (Label.text.length < maxCharacters)
			{
				var format:TextFormat = new TextFormat();
				format.bold  = true;
				format.size  = 18;
				format.align = TextFormatAlign.RIGHT;
				
				Label.appendText(str);
				Label.setTextFormat(format);
			}
		}
	}
	
}