package balance
{
	import adobe.utils.CustomActions;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.Shape;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	
	public class calculator extends Sprite
	{
		[Embed(source = "../../lib/case.png")]
		private var caseImage:Class;
		
		private var caller:*;
		
		private var escButton	: cancelButton;
		private var displayText	: calcDisplay;
		private var returnKey	: returnButton;
		private var spaceKey	: spaceButton;
		private var keyClear	: keyButton;
		private var keyDot		: keyButton;
		private var keySlash	: keyButton;		
		private var keyX		: keyButton;
		private var keyY		: keyButton;
		private var keyZ		: keyButton;
		private var key0		: keyButton;
		private var key1		: keyButton;
		private var key2		: keyButton;
		private var key3		: keyButton;
		private var key4		: keyButton;
		private var key5		: keyButton;
		private var key6		: keyButton;
		private var key7		: keyButton;
		private var key8		: keyButton;
		private var key9		: keyButton;
		
		private const PLUMBS	:String = "plumbs";
		private const LIMITS	:String = "limits";
		
		public function calculator(obj:*, restrictions:String = "", maxCharacters:int = 4):void
		{
			caller = obj;
			
			var border:Shape = new Shape();
			border.graphics.beginFill(0x006699);
			border.graphics.drawRect(0, 0, 800, 600);
			border.graphics.endFill();
			border.alpha = 0.2;
			addChild(border);
			
			var img:Bitmap = new caseImage();
			addChild(img);
			img.x = 5;
			img.y = 355;
			
			escButton = new cancelButton();
			escButton.x = 185;
			escButton.y = 335;
			addChild(escButton);
			escButton.addEventListener(MouseEvent.CLICK, onEscape);
			
			displayText = new calcDisplay(maxCharacters);
			displayText.x = 19;
			displayText.y = 360;
			addChild(displayText);
			
			keyClear = new keyButton("C");
			keyClear.x = 139;
			keyClear.y = 363;
			keyClear.scaleY = 0.9;
			addChild(keyClear);
			keyClear.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			key1 = new keyButton("1");
			key1.x = 19;
			key1.y = 396;
			addChild(key1);
			key1.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			key2 = new keyButton("2");
			key2.x = 59;
			key2.y = 396;
			addChild(key2);
			key2.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			key3 = new keyButton("3");
			key3.x = 99;
			key3.y = 396;
			addChild(key3);
			key3.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			if (restrictions == "")
			{
				keyX = new keyButton("x");
				keyX.x = 139;
				keyX.y = 396;
				addChild(keyX);		
				keyX.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			}
			
			key4 = new keyButton("4");
			key4.x = 19;
			key4.y = 436;
			addChild(key4);
			key4.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			key5 = new keyButton("5");
			key5.x = 59;
			key5.y = 436;
			addChild(key5);
			key5.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			key6 = new keyButton("6");
			key6.x = 99;
			key6.y = 436;
			addChild(key6);
			key6.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			if (restrictions == "")
			{			
				keyY = new keyButton("y");
				keyY.x = 139;
				keyY.y = 436;
				addChild(keyY);	
				keyY.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			}
			
			key7 = new keyButton("7");
			key7.x = 19;
			key7.y = 476;
			addChild(key7);
			key7.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			key8 = new keyButton("8");
			key8.x = 59;
			key8.y = 476;
			addChild(key8);	
			key8.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			key9 = new keyButton("9");
			key9.x = 99;
			key9.y = 476;
			addChild(key9);		
			key9.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			if (restrictions == "")
			{			
				keyZ = new keyButton("z");
				keyZ.x = 139;
				keyZ.y = 476;
				addChild(keyZ);	
				keyZ.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			}
			
			keyDot = new keyButton(".");
			keyDot.x = 19;
			keyDot.y = 516;
			addChild(keyDot);
			keyDot.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			key0 = new keyButton("0");
			key0.x = 59;
			key0.y = 516;
			addChild(key0);	
			key0.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			
			if (restrictions != LIMITS)
			{			
				keySlash = new keyButton("/");
				keySlash.x = 99;
				keySlash.y = 516;
				addChild(keySlash);
				keySlash.addEventListener(MouseEvent.MOUSE_DOWN, onKey);
			}
			
			returnKey = new returnButton();
			returnKey.x = 122;
			returnKey.y = 516;
			addChild(returnKey);	
			returnKey.addEventListener(MouseEvent.MOUSE_DOWN, onEnter);
			
			if (restrictions != LIMITS)
			{			
				spaceKey   = new spaceButton();
				spaceKey.x = 34;
				spaceKey.y = 554;
				addChild(spaceKey);
				spaceKey.addEventListener(MouseEvent.MOUSE_DOWN, onSpace);
			}
			
			buttonMode = false;
			tabEnabled = false;
			name = "calculator";
		}
		
		private function onEscape(event:MouseEvent):void
		{
			background.currObj = this;
			background.container.removeChild(this);
		}	
		
		private function onKey(event:MouseEvent):void
		{
			var str:String;
			if (event.target is keyButton)
			{
				str = (event.target as keyButton).Label.text;
			}
			else
			{
				str = (event.target as TextField).text;
			}
			if (str == "C")
			{
				displayText.Label.text = "";
			}
			else
			{
				displayText.refresh(str);
			}
		}
		
		private function onSpace(event:MouseEvent):void
		{
			displayText.refresh(" ");
		}		
		
		private function onEnter(event:MouseEvent):void
		{
			if (caller is TextField && (caller as DisplayObject).name == "varName")
			{
				(caller as TextField).text = displayText.Label.text;
				stage.focus = caller;
				background.container.removeChild(this);
			}
			if (caller is TextField && (caller as DisplayObject).name == "fromLimit")
			{
				(caller as TextField).text = displayText.Label.text;
				stage.focus = caller;
				background.container.removeChild(this);
			}
			if (caller is TextField && (caller as DisplayObject).name == "toLimit")
			{
				(caller as TextField).text = displayText.Label.text;
				stage.focus = caller;
				background.container.removeChild(this);
			}	
			if (caller is TextField && (caller as DisplayObject).name == "stepLimit")
			{
				(caller as TextField).text = displayText.Label.text;
				stage.focus = caller;
				background.container.removeChild(this);
			}	
			if (caller is TextField && (caller as DisplayObject).name == "plumb")
			{
				(caller as TextField).text = displayText.Label.text;
				stage.focus = caller;
				background.container.removeChild(this);
			}			
		}		
	}
	
}