package balance
{
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.events.MouseEvent;
	import flash.globalization.CollatorMode;
	import flash.text.TextField;
	import flash.text.TextFieldType;
	import flash.ui.Keyboard;
	
	public class slider extends Sprite
	{
		public static var a:Point, b:Point, m:Point;
		public static var bounding:Rectangle = new Rectangle(22, 55, 50, 0);
		public static var ball:sliderShape	 = new sliderShape();
		public static var plus:plusButton	 = new plusButton();
		public static var minus:minusButton  = new minusButton();
		
		public static var oldName:String;
		public static var nameStr:TextField;
		public static var fromStr:TextField;
		public static var toStr:TextField;
		public static var stepStr:TextField;
		public static var fromValue:Number   = 0;
		public static var toValue:Number     = 1;
		public static var stepValue:Number   = 0.1;
		public static var weightValue:Number = 0;
		
		
		public function slider():void
		{
			init();
		}
		
		private function init():void
		{
			var border:Shape = new Shape();
			border.graphics.beginFill(0xFFFFFF);
			border.graphics.drawRect(0, 0, 100, 160);
			border.graphics.endFill();
			addChild(border);
			
			a = new Point(22, 45);		// left edge
			b = new Point(72, 45);		// right edge
			m = new Point(22, 45);		// ball
			
			var rec:Shape = new Shape();
			rec.graphics.beginFill(0x6699CC);
			rec.graphics.drawRect(22, 55, 50, 2);
			rec.graphics.endFill();
			addChild(rec);
			
			plus.x = 93;
			plus.y = 55;
			plus.tabEnabled = false;
			addChild(plus);
			plus.addEventListener(MouseEvent.CLICK, onPlusClick);
			
			minus.x = 3;
			minus.y = 55;
			minus.tabEnabled = false;
			addChild(minus);
			minus.addEventListener(MouseEvent.CLICK, onMinusClick);
			
			var nameLabel:TextField = new TextField();
			nameLabel.type = TextFieldType.DYNAMIC;
			nameLabel.textColor = 0x3333CC;
			nameLabel.text = "Όνομα";
			nameLabel.width = 40;
			nameLabel.height = 18;
			nameLabel.x = 10;
			nameLabel.y = 0;
			addChild(nameLabel);	
			
			oldName = "*";
			
			nameStr = new TextField();
			nameStr.type = TextFieldType.INPUT;
			nameStr.name = "varName";
			nameStr.border = true;
			nameStr.borderColor = 0x6699CC;
			nameStr.text = "****";
			nameStr.maxChars = 4;
			nameStr.width  = 30;
			nameStr.height = 22;
			nameStr.x = 50;
			nameStr.y = 0;
			addChild(nameStr);		
			
			nameStr.addEventListener(FocusEvent.MOUSE_FOCUS_CHANGE, nameListener);
			nameStr.addEventListener(FocusEvent.KEY_FOCUS_CHANGE, nameListener);			
			
			var fromLabel:TextField = new TextField();
			fromLabel.type = TextFieldType.DYNAMIC;
			fromLabel.textColor = 0x3333CC;
			fromLabel.text = "Από";
			fromLabel.width = 25;
			fromLabel.height = 18;
			fromLabel.x = 10;
			fromLabel.y = 75;
			addChild(fromLabel);
			
			fromStr = new TextField();
			fromStr.type = TextFieldType.INPUT;
			fromStr.name = "fromLimit";
			fromStr.border = true;
			fromStr.borderColor = 0x6699CC;
			fromStr.text = "0";
			fromStr.restrict = "0-9.";
			fromStr.maxChars = 6;
			fromStr.width  = 45;
			fromStr.height = 18;
			fromStr.x = 40;
			fromStr.y = 75;
			addChild(fromStr);
			
			fromValue = parseFloat(fromStr.text);
			
			fromStr.addEventListener(FocusEvent.MOUSE_FOCUS_CHANGE, fromListener);
			fromStr.addEventListener(FocusEvent.KEY_FOCUS_CHANGE, fromListener);
			
			var toLabel:TextField = new TextField();
			toLabel.type = TextFieldType.DYNAMIC;
			toLabel.textColor = 0x3333CC;
			toLabel.text = "Έως";
			toLabel.width = 25;
			toLabel.height = 18;
			toLabel.x = 10;
			toLabel.y = 100;
			addChild(toLabel);
			
			toStr = new TextField();
			toStr.type = TextFieldType.INPUT;
			toStr.name = "toLimit";
			toStr.border = true;
			toStr.borderColor = 0x6699CC;
			toStr.text = "1";
			toStr.restrict = "0-9.";
			toStr.maxChars = 6;
			toStr.width  = 45;
			toStr.height = 18;
			toStr.x = 40;
			toStr.y = 100;
			addChild(toStr);
			
			toValue = parseFloat(toStr.text);
			
			toStr.addEventListener(FocusEvent.MOUSE_FOCUS_CHANGE, toListener);
			toStr.addEventListener(FocusEvent.KEY_FOCUS_CHANGE, toListener);		
			
			var stepLabel:TextField = new TextField();
			stepLabel.type = TextFieldType.DYNAMIC;
			stepLabel.textColor = 0x3333CC;
			stepLabel.text = "Βήμα";
			stepLabel.width = 30;
			stepLabel.height = 18;
			stepLabel.x = 10;
			stepLabel.y = 125;
			addChild(stepLabel);
			
			stepStr = new TextField();
			stepStr.type = TextFieldType.INPUT;
			stepStr.name = "stepLimit";
			stepStr.border = true;
			stepStr.borderColor = 0x6699CC;
			stepStr.text = "0.1";
			stepStr.restrict = "0-9.";
			stepStr.maxChars = 5;
			stepStr.width  = 40;
			stepStr.height = 18;
			stepStr.x = 45;
			stepStr.y = 125;
			addChild(stepStr);
			
			stepValue = parseFloat(stepStr.text);
			
			stepStr.addEventListener(FocusEvent.MOUSE_FOCUS_CHANGE, stepListener);
			stepStr.addEventListener(FocusEvent.KEY_FOCUS_CHANGE, stepListener);
			
			ball.x = 22;
			ball.y = 55;
			ball.tabEnabled = true;
			ball.focusRect  = false;
			addChild(ball);
			
			ball.addEventListener(MouseEvent.MOUSE_DOWN, ballMouseDown);
			ball.addEventListener(FocusEvent.FOCUS_IN, ballFocusIn);
			ball.addEventListener(FocusEvent.FOCUS_OUT, ballFocusOut);
		}
		
		
		
		
		
		private function ballMouseDown(e:MouseEvent):void
		{
			stage.addEventListener(MouseEvent.MOUSE_MOVE, ballMouseMove);
			stage.addEventListener(MouseEvent.MOUSE_UP, ballMouseUp);
			ball.startDrag(false, bounding);
		}
		
		private function ballMouseMove(e:MouseEvent):void
		{
			m.x = ball.x;
			m.y = ball.y;
			modulate();
		}
		
		private function ballMouseUp(e:MouseEvent):void
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, ballMouseMove);
			stage.removeEventListener(MouseEvent.MOUSE_UP, ballMouseUp);
			ball.stopDrag();
			modulate();
		}
		
		
		public static function modulate():void
		{
			var n:int	= Math.ceil((toValue - fromValue) / stepValue);
			var d:int	= b.x - a.x;
			var k:int	= 1;
			var p:int	= m.x - a.x;
			var w:Number= 0.0;
			var i:int	= 1;
			
			if (d <= n + 1)
			{
				k = Math.round((n + 1) / d);
				w = fromValue + p * k * stepValue;
			}
			else
			{
				k = Math.round(d / (n + 1));
				i = Math.floor(p / k);
				w = fromValue + i * stepValue;
			}
			
			if (w > toValue)
			{
				w = toValue;
			}
			
			if (w < fromValue)
			{
				w = fromValue;
			}
			
			weightValue = Math.round(w * 1000) / 1000;
			ball.txt.text = weightValue.toString();
			background.updateVars(weightValue, nameStr.text);
		}
		
		
		public static function deModulate():void
		{
			var tmp:int;
			if (toValue - fromValue > stepValue)
			{	
				tmp = Math.round(Point.distance(a, b) * (weightValue - fromValue) / (toValue - fromValue));
				weightValue = Math.round(weightValue * 1000) / 1000;
			}
			else
			{
				tmp = 0;
				weightValue = Math.round(fromValue * 1000) / 1000;
			}
			ball.x	= a.x + tmp;
			m.x		= ball.x;			
			ball.txt.text = weightValue.toString();
			background.updateVars(weightValue, nameStr.text);			
		}
		
		private function onPlusClick(e:MouseEvent):void
		{
			weightValue += stepValue;
			weightValue = Math.round(weightValue * 1000) / 1000;
			if (weightValue > toValue)
			{
				weightValue = toValue;
			}
			deModulate();			
		}
		
		private function onMinusClick(e:MouseEvent):void
		{
			weightValue -= stepValue;
			weightValue = Math.round(weightValue * 1000) / 1000;
			if (weightValue < fromValue)
			{
				weightValue = fromValue;
			}
			deModulate();			
		}
		
		
		private function nameListener(e:FocusEvent):void
		{
			background.currObj = e.target;
			background.adoptData(nameStr.text);
			background.updateSymbols(oldName);
			background.updateX_1s(nameStr.text);
			background.updateX_2s(nameStr.text);
			background.updateSteps(nameStr.text);
			background.updateVars(weightValue, nameStr.text);
		}		
		
		private function fromListener(e:FocusEvent):void
		{
			background.currObj = e.target;
			fromValue = parseFloat(fromStr.text);
			background.updateX_1s(nameStr.text);
			if (weightValue < fromValue)
			{
				weightValue = Math.round(fromValue * 1000) / 1000;
				deModulate();
			}
		}
		
		private function toListener(e:FocusEvent):void
		{
			background.currObj = e.target;
			toValue = parseFloat(toStr.text);
			if (toValue > 999.999)
			{
				toValue = 999.999;
				toStr.text = toValue.toString();
			}
			background.updateX_2s(nameStr.text);
			if (weightValue > toValue)
			{
				weightValue = Math.round(toValue * 1000) / 1000;
				deModulate();
			}			
		}					
		
		private function stepListener(e:FocusEvent):void
		{
			background.currObj = e.target;
			stepValue = parseFloat(stepStr.text);
			if (stepValue < 0.001)
			{
				stepValue = 0.001;
				stepStr.text = "0.001";
			}
			background.updateSteps(nameStr.text);
		}		
		
		private function ballFocusIn(e:FocusEvent):void
		{
			ball.sph.alpha = 1;
			stage.addEventListener(KeyboardEvent.KEY_DOWN, ballKeyPressed);
		}
		
		private function ballKeyPressed(e:KeyboardEvent):void
		{
			if (e.keyCode == Keyboard.LEFT && weightValue > fromValue)
			{
				weightValue -= stepValue;
				weightValue = Math.round(weightValue * 1000) / 1000;
				if (weightValue < fromValue)
				{
					weightValue = fromValue;
				}
			}
			if (e.keyCode == Keyboard.RIGHT && weightValue < toValue)
			{
				weightValue += stepValue;
				weightValue = Math.round(weightValue * 1000) / 1000;
				if (weightValue > toValue)
				{
					weightValue = toValue;
				}				
			}
			deModulate();
		}
		
		private function ballFocusOut(e:FocusEvent):void
		{
			stage.removeEventListener(KeyboardEvent.KEY_DOWN, ballKeyPressed);
			ball.sph.alpha = 0.5;
		}		
	}
}