package balance
{
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.FocusEvent;
	import flash.events.MouseEvent;	
	import flash.text.TextField;
	
	public class calcButton extends Sprite
	{
		[Embed(source = "../../lib/calculator.png")]
		private var calcImage:Class;	
		
		private const PLUMBS	:String = "plumbs";
		private const LIMITS	:String = "limits";		
		
		public function calcButton():void
		{
			init();
		}
		
		private function init():void
		{			
			var img:Bitmap = new calcImage();
			addChild(img);
			name = "calculatorButton";
			buttonMode = true;
			tabEnabled = false;
			addEventListener(MouseEvent.CLICK, onClick);
		}
		
		
		private function onClick(event:MouseEvent):void
		{
			switch ((background.currObj as DisplayObject).name)
			{
				case "varName":
					var cVar:calculator = new calculator(background.currObj);
					background.container.addChild(cVar);
					break;
				case "fromLimit":
					var cFrom:calculator = new calculator(background.currObj, LIMITS, 7);
					background.container.addChild(cFrom);
					break;
				case "toLimit":
					var cTo:calculator = new calculator(background.currObj, LIMITS, 7);
					background.container.addChild(cTo);
					break;
				case "stepLimit":
					var cStep:calculator = new calculator(background.currObj, LIMITS, 7);
					background.container.addChild(cStep);
					break;
				case "plumb":
					var cPlumb:calculator = new calculator(background.currObj, PLUMBS, 11);
					background.container.addChild(cPlumb);	
			}
		}		
	}
}