package balance
{
	import flash.geom.Point;
	
	public class ioVar extends ioNode
	{
		public var weight:Number;
		public var symbol:String;
		public var x_1   :Number;
		public var x_2   :Number;
		public var step  :Number;
		
		public function ioVar():void
		{
			weight = -1.0;
			symbol = "";
			x_1    = -1.0;
			x_2    = -1.0;
			step   = -1.0;
		}
		
		public function toString():String
		{
			var str:String = "";
			str += id + ";";
			str += kind.toString() + ";";
			str += parent + ";";
			str += child + ";";
			str += weight.toString() + ";";
			str += symbol + ";";
			str += x_1.toString() + ";";
			str += x_2.toString() + ";";
			str += step.toString();
			
			return str;
		}
		
		public function newVar(idStr:String, hookPoint:Point):void
		{
			var v:varPlumbTool = new varPlumbTool();
			v.name = idStr;
			background.container.addChild(v);
			v.weight = weight;
			v.symbol = symbol;
			v.label.text = symbol;
			v.x_1  = x_1;
			v.x_2  = x_2;
			v.step = step;						
			v.x = hookPoint.x;
			v.y = hookPoint.y;
			
			v.plug();
			
			slider.oldName		= v.symbol;
			slider.nameStr.text	= v.symbol;
			slider.fromStr.text	= v.x_1.toString();
			slider.toStr.text	= v.x_2.toString();
			slider.stepStr.text	= v.step.toString();
			slider.fromValue 	= v.x_1;
			slider.toValue 		= v.x_2;
			slider.stepValue 	= v.step;
			slider.weightValue	= v.weight;
			slider.deModulate();			
		}
	}
}